//   RW Sumomo
// ==============
// Demonstration of a Chibitsu-grade robowaifu
// -Part of the RW Foundations suite of libraries

// Filename: ./include/chibitsu/sumomo.hpp
// -Declarations of the baseline RW Sumomo project subsystem

#pragma once

#include "incls_all.hpp"

namespace rw::chibitsu {

//------------------------------------------------------------------------------
class Sumomo_b : public Chibitsu {
 public:
  Sumomo_b();                                      // default ctor
  explicit Sumomo_b(std::string const& name_tag);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
class Sumomo : public Sumomo_b {
 public:
  Sumomo();                                      // default ctor
  explicit Sumomo(std::string const& name_tag);  // tag-parm'd ctor

  auto preflight() -> bool override;

  inline auto whistle() const -> Whistle& { return whistle_; }

 private:
  unique_ptr<Whistle_b> _whistle_{make_unique<Whistle_b>("sumomo_whistle")};

  Whistle& whistle_{reference_to<Whistle>(_whistle_.get())};
};

}  // namespace rw::chibitsu

//    --=^=--

// "EMERGENCY, EMERGENCY! THIS IS A CRISIS SITUATION!!"

// rw_chibitsu_lib.v211124
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
