// RW Bumpmaster
// ==============
// Imageboard Retrieval & Archiving Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/bumpmaster.hpp
// -Declarations of the baseline RW Bumpmaster library subsystem

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
class Bumpmaster_b : public RW {
 public:
  Bumpmaster_b();                                      // default ctor
  explicit Bumpmaster_b(std::string const& name_tag);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
class Bumpmaster : public Bumpmaster_b {
 public:
  Bumpmaster();                                      // default ctor
  explicit Bumpmaster(std::string const& name_tag);  // tag-parm'd ctor

  inline auto wired() const -> Wired& { return wired_; }

 private:
  unique_ptr<Wired_b> _wired_{make_unique<Wired_b>("bumpmaster_wired")};

  Wired& wired_{reference_to<Wired>(_wired_.get())};
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v211124
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
