//  RW Foundations
// ================
// The RW Foundational Libraries

// Filename: ./include/rw/rw.hpp
// -Declarations of the baseline RW library

#pragma once

#include "incls_all.hpp"

namespace rw {

//------------------------------------------------------------------------------
/** The master base class from which all other tagged rw:: classes should derive
 * @note:
 */
class RW {
 public:
  /** Construct a @c RW object
   * @note default ctor
   */
  RW();

  /**
   * @param tag
   */
  RW(std::string const& name_tag);

  ~RW();

  /**
   * @return
   */
  auto my_tag() const -> std::string;

  /**
   * @return
   */
  auto my_id() const -> unsigned int;

  /**
   * @return
   */
  auto my_addr() const -> RW*;

  /** RW object's Tip 'tag'
   * @note: sending/receiving these is our primary means for tracing callgraphs
   * @return the object's Tip
   */
  auto tt() const -> Tip const&;

 private:
  /** Incremented by one for each new instance of this base class, when created
   */
  static unsigned long rw_id;

  /** ID's & ptrs are unique, but tags may be identical among the same types.
   * @note: eg; {sumomo.0}, {sumomo.1}, {arigato.2}, {dollhouse.3}, {arigato.4}
   */
  Tip const tip_;
};

}  // namespace rw

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v211124
// Copyright (2021)
// License MIT(Expat) https://opensource.org/licenses/MIT
