// RW Sumomo Project
// =================
// Animated avatars demo project; a pair of cute Chibitsu-grade robowaifus help

// Filename: ./main_sumomo.cpp
// -The program's entry point

#include "incls_all.hpp"

void init_sumomo(Sumomo& sumomo);
void init_kotoko(Kotoko& kotoko);

//------------------------------------------------------------------------------
int main() try {
  puts("\nWakey, wakey world...\n");  // TRACE:

  Sumomo sumomo{"Sumomo"};
  init_sumomo(sumomo);
  //
  sumomo.whistle().tweet();

  puts("");

  Kotoko kotoko{"Kotoko"};
  init_kotoko(kotoko);

  Waifusearch waifusearch{"waifusearch"};
  prt_tag(waifusearch.tt());
  prt_tag(waifusearch.curator().tt(), "waifusearch.curator()()\t");

  Bumpmaster bumpmaster{"bumpmaster"};
  prt_tag(bumpmaster.tt());
  prt_tag(bumpmaster.wired().tt(), "bumpmaster.wired()\t");

  puts("\n...leaving main()\n");  // TRACE:
} catch (runtime_error const& e) {
  cerr << e.what() << '\n';
} catch (exception const& e) {
  // TBD:
} catch (...) {
  // TBD:
}

//------------------------------------------------------------------------------
void init_sumomo(Sumomo& sumomo) {
  sumomo.preflight();
  //
  prt_tag(sumomo.tt());
  prt_tag(sumomo.animeyes().tt(), "sumomo.animeyes()\t");
  prt_tag(sumomo.atashi().tt(), "sumomo.atashi() \t");
  prt_tag(sumomo.bones().tt(), "sumomo.bones()  \t");
  prt_tag(sumomo.curator().tt(), "sumomo.curator()\t");
  prt_tag(sumomo.electro().tt(), "sumomo.electro()\t");
  prt_tag(sumomo.face().tt(), "sumomo.face()   \t");
  prt_tag(sumomo.gears().tt(), "sumomo.gears()  \t");
  prt_tag(sumomo.hearsay().tt(), "sumomo.hearsay()\t");
  prt_tag(sumomo.shell().tt(), "sumomo.shell()  \t");
  prt_tag(sumomo.wired().tt(), "sumomo.wired()  \t");

  puts("");

  prt_tag(sumomo.graphicom().tt(), "sumomo.graphicom()\t");

  puts("");

  prt_tag(sumomo.whistle().tt(), "sumomo.whistle()\t");

  puts("");
}

//------------------------------------------------------------------------------
void init_kotoko(Kotoko& kotoko) {
  kotoko.preflight();
  //
  prt_tag(kotoko.tt());
  prt_tag(kotoko.animeyes().tt(), "kotoko.animeyes()");
  prt_tag(kotoko.atashi().tt(), "kotoko.atashi() \t");
  prt_tag(kotoko.bones().tt(), "kotoko.bones()  \t");
  prt_tag(kotoko.curator().tt(), "kotoko.curator()\t");
  prt_tag(kotoko.electro().tt(), "kotoko.electro()\t");
  prt_tag(kotoko.face().tt(), "kotoko.face()   \t");
  prt_tag(kotoko.gears().tt(), "kotoko.gears()  \t");
  prt_tag(kotoko.hearsay().tt(), "kotoko.hearsay()\t");
  prt_tag(kotoko.shell().tt(), "kotoko.shell()  \t");
  prt_tag(kotoko.wired().tt(), "kotoko.wired()  \t");

  puts("");

  prt_tag(kotoko.graphicom().tt(), "kotoko.graphicom()\t");

  puts("");
}

//    --=^=--

// "We just needed the pantsu for a parachute!"

// rw_sumomo_demo.v211124
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
