//    RW Shell
// ==============
// Robowaifu Shell, and General Inboard Systems Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/shell/shell.cpp
// -Definitions of the baseline RW Shell library

#include "incls_all.hpp"

namespace rw::shell {

//------------------------------------------------------------------------------
Shell_b::Shell_b() : Shell_b{"shell_b_obj"} {}

//------------------------------------------------------------------------------
Shell_b::Shell_b(std::string const& name_tag) : RW{name_tag} {}

//------------------------------------------------------------------------------
Shell::Shell() : Shell{"shell_obj"} {}

//------------------------------------------------------------------------------
Shell::Shell(std::string const& name_tag) : Shell_b{name_tag} {}

//------------------------------------------------------------------------------
// MEMBER ACCESSORS SETS
//
// clang-format off
auto Shell::electro(Tip const& tip) const -> Electro&{
  if (_electro_) return electro_;
  else error("req'd uninstnt'd obj 'electro'", tip, "Shell::electro()");
}
auto Shell::electro() const -> Electro&{  // wrapper for self-use
  return electro(tt());
}
// clang-format on

}  // namespace rw::shell

//    --=^=--

// "______"

// rw_shell_lib.v211124
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
